EDIT - bug #6657

Reproducable "multiple representations’ exception for polytomous keys
05/19/2017 08:11 PM - Andreas Mdller

Status: Worksforme Start date:

Priority: Highest Due date:

Assignee: Katja Luther % Done: 0%
Category: taxeditor Estimated time: 0:00 hour

Target version:

Severity: major Found in Version: Release 4.7

Description

When trying to exchange or delete the taxon link in a polytomous key you get an multiple representations exception:
What | did:

1. Create a new key "MultiRepTest"

2. Create a new key node (1a) for this key

3. Attache any existing taxon to this key node
4. Save and close key

5. Reopen key and select key node

6. Remove taxon from key node

7. Save => exception

Same happens if trying to replace the taxon by another one

login : admin
editor version : 4.7.0
server : test.e-taxonomy.eu (edit-test) / rem_conf_am
schema version : 4.1.0.0.201607300000
os : Windows Server 2012 R2 6.3 amd64
java : 1.8.0_121
java.lang.IllegalStateException: Multiple representations of the same entity [eu.etaxonomy.cdm.mod
el.description.PolytomousKey#41l] are being merged. Detached: [MultiRepTest]; Detached: [MultiRepTe
st]

at org.hibernate.event.internal.EntityCopyNotAllowedObserver.entityCopyDetected (EntityCopyNotA
llowedObserver. java:37)

at org.hibernate.event.internal.MergeContext.put (MergeContext. java:245)

at org.hibernate.event.internal.DefaultMergeEventListener.entityIsDetached (DefaultMergeEventLi
stener. java:304)

at org.hibernate.event.internal.DefaultMergeEventListener.onMerge (DefaultMergeEventListener. ja
va:170)

at org.hibernate.internal.SessionImpl.fireMerge (SessionImpl. java:850)

at org.hibernate.internal.SessionImpl.merge (SessionImpl.java:832)

at org.hibernate.engine.spi.CascadingActions$6.cascade (CascadingActions. java:260)

at org.hibernate.engine.internal.Cascade.cascadeToOne (Cascade. java:398)

at org.hibernate.engine.internal.Cascade.cascadeAssociation (Cascade. java:323)

at org.hibernate.engine.internal.Cascade.cascadeProperty (Cascade.java:162)

at org.hibernate.engine.internal.Cascade.cascade (Cascade.java:111)

at org.hibernate.event.internal.DefaultMergeEventListener.cascadeOnMerge (DefaultMergeEventList
ener.java:468)

at org.hibernate.event.internal.DefaultMergeEventListener.entityIsDetached (DefaultMergeEventLi
stener. java:327)

at

org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction (Trans
actionAspectSupport.java:281)

at org.springframework.transaction.interceptor.TransactionInterceptor.invoke (TransactionInterc
eptor.java:96)

at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed (ReflectiveMethodInvoca
tion.java:179)

at org.springframework.aop.framework.JdkDynamicAopProxy.invoke (JdkDynamicAopProxy.java:208)

at com.sun.proxy.S$SProxy674.merge (Unknown Source)
sun.reflect.NativeMethodAccessorImpl.invokeO (Native Method)
sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)
sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)
java.lang.reflect.Method.invoke (Method. java:497)
org.springframework.aop.support.AopUtils.invokeJoinpointUsingReflection (AopUtils. java:302)

org.eclipse.core.runtime.internal.adaptor.EclipseAppLlauncher.runApplication (EclipseAppLaunc

her.java:134)

at
104)
at
at
at
at
at
at
at
at
at

org.eclipse.core.runtime.internal.adaptor.EclipseAppLauncher.start (EclipseAppLauncher. java:

org.eclipse.core.runtime.adaptor.EclipseStarter.run(EclipseStarter.java:388)
org.eclipse.core.runtime.adaptor.EclipseStarter.run (EclipseStarter.java:243)
sun.reflect.NativeMethodAccessorImpl.invoke(O (Native Method)
sun.reflect.NativeMethodAccessorImpl.invoke (NativeMethodAccessorImpl. java:62)
sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)
java.lang.reflect.Method. invoke (Method. java:498)
org.eclipse.equinox.launcher.Main.invokeFramework (Main. java:673)
org.eclipse.equinox.launcher.Main.basicRun (Main. java:610)
org.eclipse.equinox.launcher.Main.run (Main.java:1519)

Related issues:

Related to EDIT - bug #6706: Sometimes selected taxa are not synchronized in ... New

Related to EDIT - bug #6971: Collect all remaining appearances of multiple re... New

Associated revisions

Revision b3f33ee9 - 05/30/2017 02:46 PM - Katja Luther

fix #6657: load polytomouskey with propertypath in key editor

History

#1 - 05/19/2017 08:12 PM - Andreas Miller

- Description updated

- Found in Version set to Release 4.7

#2 - 05/30/2017 02:37 PM - Katja Luther

This exception does not appear every time, when it appears the session debugging looks like this:

<<< Root Entity PolytomousKey with id 10 >>>
Duplicate CDM Entities,

- key:PolytomousKey/10 in entity eu.etaxonomy.cdm.model.description.PolytomousKeyNode with id : 84
-— entity belongs to cache(s)

- :PolytomousKey/10
—-— entity belongs to cache(s) : {TIC}

- key:PolytomousKey/10 in entity eu.etaxonomy.cdm.model.description.PolytomousKeyNode with id : 10
—-— entity belongs to cache(s) : {TIC}

- key:PolytomousKey/10 in entity eu.etaxonomy.cdm.model.description.PolytomousKeyNode with id : 84

—— entity belongs to cache (s)

Not In Cache Entities,
- key:PolytomousKey/10 of entity PolytomousKeyNode

The node with Id 84 seems not to be loaded correctly and is not in the cache.

#3 - 05/30/2017 02:47 PM - Katja Luther

- Status changed from New to Resolved

- % Done changed from 0 to 50

Applied in changeset taxeditor|b3f33ee9b93dfe91eb576ch7686abdc1284822df.

#4 - 05/30/2017 02:48 PM - Katja Luther

- Assignee changed from Katja Luther to Andreas Miiller

- % Done changed from 50 to 0
https://dev.e-taxonomy.eu/redmine/projects/edit/repository/taxeditor/revisions/b3f33ee9b93dfe91eb576cb7686abdc1284822df

This exception does not appear every time, when it appears the session debugging looks like this:

<<< Root Entity PolytomousKey with id 10 >>>
Duplicate CDM Entities,
- key:PolytomousKey/10 in entity eu.etaxonomy.cdm.model.description.PolytomousKeyNode with id : 84
-— entity belongs to cache(s)

— :PolytomousKey/10
—-— entity belongs to cache(s) : {TIC}

— key:PolytomousKey/10 in entity eu.etaxonomy.cdm.model.description.PolytomousKeyNode with id : 10
—-— entity belongs to cache(s) : {TIC}

- key:PolytomousKey/10 in entity eu.etaxonomy.cdm.model.description.PolytomousKeyNode with id : 84

—-— entity belongs to cache(s)

Not In Cache Entities,
- key:PolytomousKey/10 of entity PolytomousKeyNode

loading the polytomouskey with propertyPath seems to solve the problem.

please review.

#5 - 06/08/2017 10:55 AM - Andreas Mdiller

- Description updated

#6 - 06/08/2017 11:14 AM - Andreas Miiller
- Description updated

- Status changed from Resolved to Feedback

In most cases this seems to work now. However | still have multiple strange behaviors with key "KomplexKey" on edit-test/rem_conf_am.
It was almost impossible to change any node here (either by adding a taxon or changing the modifying text). | usually get:

login : admin
editor version : 4.8.0.201706072259
server : test.e-taxonomy.eu (edit-test) / rem_conf_am
schema version : 4.7.0.0.201710040000
os : Windows Server 2012 R2 6.3 amd64
java : 1.8.0_121
java.lang.IllegalStateException: Multiple representations of the same entity [eu.etaxonomy.cdm.model.descripti
on.PolytomousKey#12] are being merged. Detached: [Ich]; Detached: [Ich]

at org.hibernate.event.internal.EntityCopyNotAllowedObserver.entityCopyDetected (EntityCopyNotAllowedObserv
er.java:37)

at org.hibernate.event.internal.MergeContext.put (MergeContext.java:245)

at org.hibernate.event.internal.DefaultMergeEventListener.entityIsDetached (DefaultMergeEventListener. java:
304)

at org.hibernate.event.internal.DefaultMergeEventListener.onMerge (DefaultMergeEventListener.java:170)

at org.hibernate.internal.SessionImpl.fireMerge (SessionImpl. java:850)

at org.hibernate.internal.SessionImpl.merge (SessionImpl. java:832)

at org.hibernate.engine.spi.CascadingActions$6.cascade (CascadingActions. java:260)

at org.hibernate.engine.internal.Cascade.cascadeToOne (Cascade. java:398)

at org.hibernate.engine.internal.Cascade.cascadeAssociation (Cascade.java:323)

at org.hibernate.engine.internal.Cascade.cascadeProperty (Cascade.java:162)

at org.hibernate.engine.internal.Cascade.cascade (Cascade. java:111)

at org.hibernate.event.internal.DefaultMergeEventListener.cascadeOnMerge (DefaultMergeEventListener. java:46
8)

at org.hibernate.event.internal.DefaultMergeEventListener.entityIsDetached (DefaultMergeEventListener. java:
327)

at org.hibernate.event.internal.DefaultMergeEventListener.onMerge (DefaultMergeEventListener.java:170)

at org.hibernate.internal.SessionImpl.fireMerge (SessionImpl. java:850)

at org.hibernate.internal.SessionImpl.merge (SessionImpl. java:832)

at org.hibernate.engine.spi.CascadingActions$6.cascade (CascadingActions. java:260)

at org.hibernate.engine.internal.Cascade.cascadeToOne (Cascade. java:398)

at org.hibernate.engine.internal.Cascade.cascadeAssociation (Cascade.java:323)

at org.hibernate.engine.internal.Cascade.cascadeProperty (Cascade.java:162)

at org.hibernate.engine.internal.Cascade.cascadeCollectionElements (Cascade.java:431)

at org.hibernate.engine.internal.Cascade.cascadeCollection (Cascade.java:363)

at org.hibernate.engine.internal.Cascade.cascadeAssociation (Cascade.java:326)

Only once | was successful with Edge 2b (maybe because | did before rename the key in the same session, renaming was also successful).
Strange is that trying to remove this exact taxon again leads to the original exception while at most other places it does not.
We need to check if there is something special about this exact key which leads to the exceptions.

There is also an other issue with adding taxon nodes (#6706) which might be related.

#7 - 06/08/2017 11:15 AM - Andreas Mdiller

- Assignee changed from Andreas Miiller to Katja Luther

#8 - 06/08/2017 11:17 AM - Andreas Mdiller

- Related to bug #6706: Sometimes selected taxa are not synchronized in PolytomousKey Editor added

#9 - 07/21/2017 11:59 AM - Katja Luther

- Target version changed from Release 4.8 to Release 4.10

#10 - 09/22/2017 10:56 AM - Katja Luther
- Status changed from Feedback to Worksforme

- Target version deleted (Release 4.10)

this "reproducable" multiple representation exception is not reproducable anymore. Close this ticket and create a new one to collect remaining
exceptions in migrated editor.

#11 - 09/22/2017 10:58 AM - Katja Luther

- Related to bug #6971: Collect all remaining appearances of multiple representation exceptions since 4.10 added

#12 - 02/21/2020 10:54 AM - Andreas Kohlbecker

- Tags set to multiple-representations-problem
https://dev.e-taxonomy.eu/redmine/issues/6706
http://www.tcpdf.org

